import $ from 'jquery';
import Form from 'ep/js/Form';

export default class SelectMotorcycle extends Form
{
    constructor(el)
    {
        super(el);

        this.brand = this.$el.find('[name="brandId"]')[0].ep;
        this.model = this.$el.find('[name="modelId"]')[0].ep;
        this.motorcycle = this.$el.find('[name="motorcycleId"]')[0].ep;
        this.$reset = this.$el.find('.select-motorcycle__reset');

        $(this.brand).on('change', this.updateModel.bind(this));
        $(this.model).on('change', this.updateMotorcycle.bind(this));
        $(this.motorcycle).on('change', this.updateButton.bind(this)).change();
        this.$reset.on('click', function() {

        });
    }

    updateModel()
    {
        let brandId = parseInt(this.brand.value);

        this.model.enabled = false;
        this.motorcycle.enabled = false;

        if (!isNaN(brandId)) {
            if (this.modelXhr !== undefined) {
                this.modelXhr.abort();
            }

            this.modelXhr = $.post(ep.ajax_url, {
                action: 'gath_moto_get_models',
                brand_id: brandId
            }, function(response) {
                this.model.setOptions(response);
            }.bind(this));
        }
    }

    updateMotorcycle()
    {
        let modelId = this.model.value;

        this.motorcycle.enabled = false;

        if (!isNaN(modelId)) {
            if (this.motorcycleXhr !== undefined) {
                this.motorcycleXhr.abort();
            }

            this.motorcycleXhr = $.post(ep.ajax_url, {
                action: 'gath_moto_get_motorcycles',
                model_id: modelId,
            }, function(response) {
                this.motorcycle.setOptions(response);
            }.bind(this));
        }
    }

    updateButton()
    {
        let motorcycleId = parseInt(this.motorcycle.value);
        this.submit.enabled = !isNaN(motorcycleId);
    }
}