<?php
namespace Ep\Gath\Moto;

use Ep\Wp\View\ViewInterface;
use Interop\Container\ContainerInterface;
use Laminas\Form\FormInterface;
use Laminas\ServiceManager\Factory\FactoryInterface;
use Laminas\ServiceManager\PluginManagerInterface;

/**
 * Class SelectMotorcycleFactory
 *
 * @package Gath\Moto\View
 * @author Elektronika Perhoč <support@ep.hr>
 * @link https://bitbucket.org/elektronika-perhoc/gath-moto
 */
class SelectMotorcycleViewFactory implements FactoryInterface
{
    /**
     * Create an object
     *
     * @param  ContainerInterface $container
     * @param  string $requestedName
     * @param  null|array $options
     *
     * @return ViewInterface
     *
     * @throws \Psr\Container\ContainerExceptionInterface
     * @throws \Psr\Container\NotFoundExceptionInterface
     */
    public function __invoke(ContainerInterface $container, $requestedName, array $options = null)
    {
        $gath = $container->get('gath');
        /** @var PluginManagerInterface $forms */
        $forms = $container->get('FormElementManager');
        /** @var FormInterface $form */
        $form = $forms->get('gath.select_motorcycle');
        $selected = $container->get('gath.selected_motorcycle');

        return new SelectMotorcycleView($gath, $form, $selected);
    }
}
